Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.apache.commons.math.analysis.solvers
Class LaguerreSolver

    java.lang.Object
      org.apache.commons.math.ConvergingAlgorithmImpl
          org.apache.commons.math.analysis.solvers.UnivariateRealSolverImpl
              org.apache.commons.math.analysis.solvers.LaguerreSolver

All Implemented Interfaces:
  UnivariateRealSolver, ConvergingAlgorithm

    public class LaguerreSolver

extends UnivariateRealSolverImpl

Implements the Laguerre's Method for root finding of real coefficient polynomials. For reference, see A First Course in Numerical Analysis, ISBN 048641454X, chapter 8.

Laguerre's method is global in the sense that it can start with any initial approximation and be able to solve all roots from that point.

Since:
  1.2
Version:
  $Revision: 1070725 $ $Date: 2011-02-15 02:31:12 +0100 (mar. 15 fÃ©vr. 2011) $

Field Summary

Fields inherited from class org.apache.commons.math.analysis.solvers.UnivariateRealSolverImpl
`defaultFunctionValueAccuracy, f, functionValue, functionValueAccuracy, result, resultComputed`

Fields inherited from class org.apache.commons.math.ConvergingAlgorithmImpl
`absoluteAccuracy, defaultAbsoluteAccuracy, defaultMaximalIterationCount, defaultRelativeAccuracy, iterationCount, maximalIterationCount, relativeAccuracy`

Constructor Summary
`LaguerreSolver()` Deprecated. in 2.2 (to be removed in 3.0)
`LaguerreSolver(UnivariateRealFunction f)` Deprecated. as of 2.0 the function to solve is passed as an argument to the `solve(UnivariateRealFunction, double, double)` or `UnivariateRealSolver.solve(UnivariateRealFunction, double, double, double)` method.

Method Summary
`PolynomialFunction` | `getPolynomialFunction()` Deprecated. as of 2.0 the function is not stored anymore within the instance.
`protected boolean` | `isRootOK(double min, double max, Complex z)` Returns true iff the given complex root is actually a real zero in the given interval, within the solver tolerance level.
`Complex` | `solve(Complex[] coefficients, Complex initial)` Deprecated. in 2.2.
`double` | `solve(double min, double max)` Deprecated.
`double` | `solve(double min, double max, double initial)` Deprecated.
`double` | `solve(int maxEval, UnivariateRealFunction f, double min, double max)` Find a real root in the given interval.
`double` | `solve(int maxEval, UnivariateRealFunction f, double min, double max, double initial)` Find a real root in the given interval with initial value.
`double` | `solve(UnivariateRealFunction f, double min, double max)` Deprecated. in 2.2 (to be removed in 3.0).
`double` | `solve(UnivariateRealFunction f, double min, double max, double initial)` Deprecated. in 2.2 (to be removed in 3.0).
`Complex[]` | `solveAll(Complex[] coefficients, Complex initial)` Deprecated. in 2.2.
`Complex[]` | `solveAll(double[] coefficients, double initial)` Deprecated. in 2.2.

Methods inherited from class org.apache.commons.math.analysis.solvers.UnivariateRealSolverImpl
`checkResultComputed, clearResult, getFunctionValue, getFunctionValueAccuracy, getResult, isBracketing, isSequence, resetFunctionValueAccuracy, setFunctionValueAccuracy, setResult, setResult, verifyBracketing, verifyInterval, verifySequence`

Methods inherited from class org.apache.commons.math.ConvergingAlgorithmImpl
`getAbsoluteAccuracy, getIterationCount, getMaximalIterationCount, getRelativeAccuracy, incrementIterationsCounter, resetAbsoluteAccuracy, resetIterationsCounter, resetMaximalIterationCount, resetRelativeAccuracy, setAbsoluteAccuracy, setMaximalIterationCount, setRelativeAccuracy`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Methods inherited from interface org.apache.commons.math.ConvergingAlgorithm
`getAbsoluteAccuracy, getIterationCount, getMaximalIterationCount, getRelativeAccuracy, resetAbsoluteAccuracy, resetMaximalIterationCount, resetRelativeAccuracy, setAbsoluteAccuracy, setMaximalIterationCount, setRelativeAccuracy`

Constructor Detail

### LaguerreSolver

    @Deprecated
    public LaguerreSolver(UnivariateRealFunction f)
                   throws IllegalArgumentException

  Deprecated. as of 2.0 the function to solve is passed as an argument to the `solve(UnivariateRealFunction, double, double)` or `UnivariateRealSolver.solve(UnivariateRealFunction, double, double, double)` method.

  Construct a solver for the given function.

  Parameters:
    `f` - function to solve
  Throws:
    `IllegalArgumentException` - if function is not polynomial

### LaguerreSolver

    @Deprecated
    public LaguerreSolver()

  Deprecated. in 2.2 (to be removed in 3.0)

  Construct a solver.

Method Detail

### getPolynomialFunction

    @Deprecated
    public PolynomialFunction getPolynomialFunction()

  Deprecated. as of 2.0 the function is not stored anymore within the instance.

  Returns a copy of the polynomial function.

  Returns:
    a fresh copy of the polynomial function

### solve

    @Deprecated
    public double solve(double min,
                                   double max)
                 throws ConvergenceException,
                        FunctionEvaluationException

  Deprecated.

  Solve for a zero root in the given interval.

  A solver may require that the interval brackets a single zero root. Solvers that do require bracketing should be able to handle the case where one of the endpoints is itself a root.

  Parameters:
    `min` - the lower bound for the interval.
    `max` - the upper bound for the interval.
  Returns:
    a value where the function is zero
  Throws:
    `ConvergenceException` - if the maximum iteration count is exceeded or the solver detects convergence problems otherwise.
    `FunctionEvaluationException` - if an error occurs evaluating the function

### solve

    @Deprecated
    public double solve(double min,
                                   double max,
                                   double initial)
                 throws ConvergenceException,
                        FunctionEvaluationException

  Deprecated.

  Solve for a zero in the given interval, start at startValue.

  A solver may require that the interval brackets a single zero root. Solvers that do require bracketing should be able to handle the case where one of the endpoints is itself a root.

  Parameters:
    `min` - the lower bound for the interval.
    `max` - the upper bound for the interval.
    `initial` - the start value to use
  Returns:
    a value where the function is zero
  Throws:
    `ConvergenceException` - if the maximum iteration count is exceeded or the solver detects convergence problems otherwise.
    `FunctionEvaluationException` - if an error occurs evaluating the function

### solve

    public double solve(int maxEval,
                        UnivariateRealFunction f,
                        double min,
                        double max,
                        double initial)
                 throws ConvergenceException,
                        FunctionEvaluationException

  Find a real root in the given interval with initial value.

  Requires bracketing condition.

  Overrides:
    `solve` in class `UnivariateRealSolverImpl`
  Parameters:
    `f` - function to solve (must be polynomial)
    `min` - the lower bound for the interval
    `max` - the upper bound for the interval
    `initial` - the start value to use
    `maxEval` - Maximum number of evaluations.
  Returns:
    the point at which the function value is zero
  Throws:
    `ConvergenceException` - if the maximum iteration count is exceeded or the solver detects convergence problems otherwise
    `FunctionEvaluationException` - if an error occurs evaluating the function
    `IllegalArgumentException` - if any parameters are invalid

### solve

    @Deprecated
    public double solve(UnivariateRealFunction f,
                                   double min,
                                   double max,
                                   double initial)
                 throws ConvergenceException,
                        FunctionEvaluationException

  Deprecated. in 2.2 (to be removed in 3.0).

  Find a real root in the given interval with initial value.

  Requires bracketing condition.

  Parameters:
    `f` - function to solve (must be polynomial)
    `min` - the lower bound for the interval
    `max` - the upper bound for the interval
    `initial` - the start value to use
  Returns:
    the point at which the function value is zero
  Throws:
    `ConvergenceException` - if the maximum iteration count is exceeded or the solver detects convergence problems otherwise
    `FunctionEvaluationException` - if an error occurs evaluating the function
    `IllegalArgumentException` - if any parameters are invalid

### solve

    public double solve(int maxEval,
                        UnivariateRealFunction f,
                        double min,
                        double max)
                 throws ConvergenceException,
                        FunctionEvaluationException

  Find a real root in the given interval.

  Despite the bracketing condition, the root returned by solve(Complex[], Complex) may not be a real zero inside [min, max]. For example, p(x) = x^3 + 1, min = -2, max = 2, initial = 0. We can either try another initial value, or, as we did here, call solveAll() to obtain all roots and pick up the one that we're looking for.

  Overrides:
    `solve` in class `UnivariateRealSolverImpl`
  Parameters:
    `f` - the function to solve
    `min` - the lower bound for the interval
    `max` - the upper bound for the interval
    `maxEval` - Maximum number of evaluations.
  Returns:
    the point at which the function value is zero
  Throws:
    `ConvergenceException` - if the maximum iteration count is exceeded or the solver detects convergence problems otherwise
    `FunctionEvaluationException` - if an error occurs evaluating the function
    `IllegalArgumentException` - if any parameters are invalid

### solve

    @Deprecated
    public double solve(UnivariateRealFunction f,
                                   double min,
                                   double max)
                 throws ConvergenceException,
                        FunctionEvaluationException

  Deprecated. in 2.2 (to be removed in 3.0).

  Find a real root in the given interval.

  Despite the bracketing condition, the root returned by solve(Complex[], Complex) may not be a real zero inside [min, max]. For example, p(x) = x^3 + 1, min = -2, max = 2, initial = 0. We can either try another initial value, or, as we did here, call solveAll() to obtain all roots and pick up the one that we're looking for.

  Parameters:
    `f` - the function to solve
    `min` - the lower bound for the interval
    `max` - the upper bound for the interval
  Returns:
    the point at which the function value is zero
  Throws:
    `ConvergenceException` - if the maximum iteration count is exceeded or the solver detects convergence problems otherwise
    `FunctionEvaluationException` - if an error occurs evaluating the function
    `IllegalArgumentException` - if any parameters are invalid

### isRootOK

    protected boolean isRootOK(double min,
                               double max,
                               Complex z)

  Returns true iff the given complex root is actually a real zero in the given interval, within the solver tolerance level.

  Parameters:
    `min` - the lower bound for the interval
    `max` - the upper bound for the interval
    `z` - the complex root
  Returns:
    true iff z is the sought-after real zero

### solveAll

    @Deprecated
    public Complex[] solveAll(double[] coefficients,
                                         double initial)
                       throws ConvergenceException,
                              FunctionEvaluationException

  Deprecated. in 2.2.

  Find all complex roots for the polynomial with the given coefficients, starting from the given initial value.

  Parameters:
    `coefficients` - the polynomial coefficients array
    `initial` - the start value to use
  Returns:
    the point at which the function value is zero
  Throws:
    `ConvergenceException` - if the maximum iteration count is exceeded or the solver detects convergence problems otherwise
    `FunctionEvaluationException` - if an error occurs evaluating the function
    `IllegalArgumentException` - if any parameters are invalid

### solveAll

    @Deprecated
    public Complex[] solveAll(Complex[] coefficients,
                                         Complex initial)
                       throws MaxIterationsExceededException,
                              FunctionEvaluationException

  Deprecated. in 2.2.

  Find all complex roots for the polynomial with the given coefficients, starting from the given initial value.

  Parameters:
    `coefficients` - the polynomial coefficients array
    `initial` - the start value to use
  Returns:
    the point at which the function value is zero
  Throws:
    `MaxIterationsExceededException` - if the maximum iteration count is exceeded or the solver detects convergence problems otherwise
    `FunctionEvaluationException` - if an error occurs evaluating the function
    `IllegalArgumentException` - if any parameters are invalid

### solve

    @Deprecated
    public Complex solve(Complex[] coefficients,
                                    Complex initial)
                  throws MaxIterationsExceededException,
                         FunctionEvaluationException

  Deprecated. in 2.2.

  Find a complex root for the polynomial with the given coefficients, starting from the given initial value.

  Parameters:
    `coefficients` - the polynomial coefficients array
    `initial` - the start value to use
  Returns:
    the point at which the function value is zero
  Throws:
    `MaxIterationsExceededException` - if the maximum iteration count is exceeded or the solver detects convergence problems otherwise
    `FunctionEvaluationException` - if an error occurs evaluating the function
    `IllegalArgumentException` - if any parameters are invalid

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright © 2003-2011 The Apache Software Foundation. All Rights Reserved.